git-stash.shon commit Implement 'git stash save --patch' (dda1f2a)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless show [<stash>]
   7   or: $dashless drop [-q|--quiet] [<stash>]
   8   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
   9   or: $dashless branch <branchname> [<stash>]
  10   or: $dashless [save [--keep-index] [-q|--quiet] [<message>]]
  11   or: $dashless clear"
  12
  13SUBDIRECTORY_OK=Yes
  14OPTIONS_SPEC=
  15. git-sh-setup
  16require_work_tree
  17cd_to_toplevel
  18
  19TMP="$GIT_DIR/.git-stash.$$"
  20trap 'rm -f "$TMP-*"' 0
  21
  22ref_stash=refs/stash
  23
  24if git config --get-colorbool color.interactive; then
  25       help_color="$(git config --get-color color.interactive.help 'red bold')"
  26       reset_color="$(git config --get-color '' reset)"
  27else
  28       help_color=
  29       reset_color=
  30fi
  31
  32no_changes () {
  33        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  34        git diff-files --quiet --ignore-submodules
  35}
  36
  37clear_stash () {
  38        if test $# != 0
  39        then
  40                die "git stash clear with parameters is unimplemented"
  41        fi
  42        if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
  43        then
  44                git update-ref -d $ref_stash $current
  45        fi
  46}
  47
  48create_stash () {
  49        stash_msg="$1"
  50
  51        git update-index -q --refresh
  52        if no_changes
  53        then
  54                exit 0
  55        fi
  56
  57        # state of the base commit
  58        if b_commit=$(git rev-parse --verify HEAD)
  59        then
  60                head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
  61        else
  62                die "You do not have the initial commit yet"
  63        fi
  64
  65        if branch=$(git symbolic-ref -q HEAD)
  66        then
  67                branch=${branch#refs/heads/}
  68        else
  69                branch='(no branch)'
  70        fi
  71        msg=$(printf '%s: %s' "$branch" "$head")
  72
  73        # state of the index
  74        i_tree=$(git write-tree) &&
  75        i_commit=$(printf 'index on %s\n' "$msg" |
  76                git commit-tree $i_tree -p $b_commit) ||
  77                die "Cannot save the current index state"
  78
  79        if test -z "$patch_mode"
  80        then
  81
  82                # state of the working tree
  83                w_tree=$( (
  84                        rm -f "$TMP-index" &&
  85                        cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
  86                        GIT_INDEX_FILE="$TMP-index" &&
  87                        export GIT_INDEX_FILE &&
  88                        git read-tree -m $i_tree &&
  89                        git add -u &&
  90                        git write-tree &&
  91                        rm -f "$TMP-index"
  92                ) ) ||
  93                        die "Cannot save the current worktree state"
  94
  95        else
  96
  97                rm -f "$TMP-index" &&
  98                GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
  99
 100                # find out what the user wants
 101                GIT_INDEX_FILE="$TMP-index" \
 102                        git add--interactive --patch=stash -- &&
 103
 104                # state of the working tree
 105                w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
 106                die "Cannot save the current worktree state"
 107
 108                git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
 109                test -s "$TMP-patch" ||
 110                die "No changes selected"
 111
 112                rm -f "$TMP-index" ||
 113                die "Cannot remove temporary index (can't happen)"
 114
 115        fi
 116
 117        # create the stash
 118        if test -z "$stash_msg"
 119        then
 120                stash_msg=$(printf 'WIP on %s' "$msg")
 121        else
 122                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
 123        fi
 124        w_commit=$(printf '%s\n' "$stash_msg" |
 125                git commit-tree $w_tree -p $b_commit -p $i_commit) ||
 126                die "Cannot record working tree state"
 127}
 128
 129save_stash () {
 130        keep_index=
 131        patch_mode=
 132        while test $# != 0
 133        do
 134                case "$1" in
 135                --keep-index)
 136                        keep_index=t
 137                        ;;
 138                --no-keep-index)
 139                        keep_index=
 140                        ;;
 141                -p|--patch)
 142                        patch_mode=t
 143                        keep_index=t
 144                        ;;
 145                -q|--quiet)
 146                        GIT_QUIET=t
 147                        ;;
 148                *)
 149                        break
 150                        ;;
 151                esac
 152                shift
 153        done
 154
 155        stash_msg="$*"
 156
 157        git update-index -q --refresh
 158        if no_changes
 159        then
 160                say 'No local changes to save'
 161                exit 0
 162        fi
 163        test -f "$GIT_DIR/logs/$ref_stash" ||
 164                clear_stash || die "Cannot initialize stash"
 165
 166        create_stash "$stash_msg"
 167
 168        # Make sure the reflog for stash is kept.
 169        : >>"$GIT_DIR/logs/$ref_stash"
 170
 171        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
 172                die "Cannot save the current status"
 173        say Saved working directory and index state "$stash_msg"
 174
 175        if test -z "$patch_mode"
 176        then
 177                git reset --hard ${GIT_QUIET:+-q}
 178
 179                if test -n "$keep_index" && test -n $i_tree
 180                then
 181                        git read-tree --reset -u $i_tree
 182                fi
 183        else
 184                git apply -R < "$TMP-patch" ||
 185                die "Cannot remove worktree changes"
 186
 187                if test -z "$keep_index"
 188                then
 189                        git reset
 190                fi
 191        fi
 192}
 193
 194have_stash () {
 195        git rev-parse --verify $ref_stash >/dev/null 2>&1
 196}
 197
 198list_stash () {
 199        have_stash || return 0
 200        git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
 201        sed -n -e 's/^[.0-9a-f]* refs\///p'
 202}
 203
 204show_stash () {
 205        flags=$(git rev-parse --no-revs --flags "$@")
 206        if test -z "$flags"
 207        then
 208                flags=--stat
 209        fi
 210
 211        w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
 212        b_commit=$(git rev-parse --verify "$w_commit^") &&
 213        git diff $flags $b_commit $w_commit
 214}
 215
 216apply_stash () {
 217        git update-index -q --refresh &&
 218        git diff-files --quiet --ignore-submodules ||
 219                die 'Cannot apply to a dirty working tree, please stage your changes'
 220
 221        unstash_index=
 222
 223        while test $# != 0
 224        do
 225                case "$1" in
 226                --index)
 227                        unstash_index=t
 228                        ;;
 229                -q|--quiet)
 230                        GIT_QUIET=t
 231                        ;;
 232                *)
 233                        break
 234                        ;;
 235                esac
 236                shift
 237        done
 238
 239        # current index state
 240        c_tree=$(git write-tree) ||
 241                die 'Cannot apply a stash in the middle of a merge'
 242
 243        # stash records the work tree, and is a merge between the
 244        # base commit (first parent) and the index tree (second parent).
 245        s=$(git rev-parse --verify --default $ref_stash "$@") &&
 246        w_tree=$(git rev-parse --verify "$s:") &&
 247        b_tree=$(git rev-parse --verify "$s^1:") &&
 248        i_tree=$(git rev-parse --verify "$s^2:") ||
 249                die "$*: no valid stashed state found"
 250
 251        unstashed_index_tree=
 252        if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
 253                        test "$c_tree" != "$i_tree"
 254        then
 255                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 256                test $? -ne 0 &&
 257                        die 'Conflicts in index. Try without --index.'
 258                unstashed_index_tree=$(git write-tree) ||
 259                        die 'Could not save index tree'
 260                git reset
 261        fi
 262
 263        eval "
 264                GITHEAD_$w_tree='Stashed changes' &&
 265                GITHEAD_$c_tree='Updated upstream' &&
 266                GITHEAD_$b_tree='Version stash was based on' &&
 267                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 268        "
 269
 270        if test -n "$GIT_QUIET"
 271        then
 272                export GIT_MERGE_VERBOSITY=0
 273        fi
 274        if git merge-recursive $b_tree -- $c_tree $w_tree
 275        then
 276                # No conflict
 277                if test -n "$unstashed_index_tree"
 278                then
 279                        git read-tree "$unstashed_index_tree"
 280                else
 281                        a="$TMP-added" &&
 282                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 283                        git read-tree --reset $c_tree &&
 284                        git update-index --add --stdin <"$a" ||
 285                                die "Cannot unstage modified files"
 286                        rm -f "$a"
 287                fi
 288                squelch=
 289                if test -n "$GIT_QUIET"
 290                then
 291                        squelch='>/dev/null 2>&1'
 292                fi
 293                eval "git status $squelch" || :
 294        else
 295                # Merge conflict; keep the exit status from merge-recursive
 296                status=$?
 297                if test -n "$unstash_index"
 298                then
 299                        echo >&2 'Index was not unstashed.'
 300                fi
 301                exit $status
 302        fi
 303}
 304
 305drop_stash () {
 306        have_stash || die 'No stash entries to drop'
 307
 308        while test $# != 0
 309        do
 310                case "$1" in
 311                -q|--quiet)
 312                        GIT_QUIET=t
 313                        ;;
 314                *)
 315                        break
 316                        ;;
 317                esac
 318                shift
 319        done
 320
 321        if test $# = 0
 322        then
 323                set x "$ref_stash@{0}"
 324                shift
 325        fi
 326        # Verify supplied argument looks like a stash entry
 327        s=$(git rev-parse --verify "$@") &&
 328        git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
 329        git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
 330        git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
 331                die "$*: not a valid stashed state"
 332
 333        git reflog delete --updateref --rewrite "$@" &&
 334                say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
 335
 336        # clear_stash if we just dropped the last stash entry
 337        git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
 338}
 339
 340apply_to_branch () {
 341        have_stash || die 'Nothing to apply'
 342
 343        test -n "$1" || die 'No branch name specified'
 344        branch=$1
 345
 346        if test -z "$2"
 347        then
 348                set x "$ref_stash@{0}"
 349        fi
 350        stash=$2
 351
 352        git checkout -b $branch $stash^ &&
 353        apply_stash --index $stash &&
 354        drop_stash $stash
 355}
 356
 357# Main command set
 358case "$1" in
 359list)
 360        shift
 361        if test $# = 0
 362        then
 363                set x -n 10
 364                shift
 365        fi
 366        list_stash "$@"
 367        ;;
 368show)
 369        shift
 370        show_stash "$@"
 371        ;;
 372save)
 373        shift
 374        save_stash "$@"
 375        ;;
 376apply)
 377        shift
 378        apply_stash "$@"
 379        ;;
 380clear)
 381        shift
 382        clear_stash "$@"
 383        ;;
 384create)
 385        if test $# -gt 0 && test "$1" = create
 386        then
 387                shift
 388        fi
 389        create_stash "$*" && echo "$w_commit"
 390        ;;
 391drop)
 392        shift
 393        drop_stash "$@"
 394        ;;
 395pop)
 396        shift
 397        if apply_stash "$@"
 398        then
 399                test -z "$unstash_index" || shift
 400                drop_stash "$@"
 401        fi
 402        ;;
 403branch)
 404        shift
 405        apply_to_branch "$@"
 406        ;;
 407*)
 408        if test $# -eq 0
 409        then
 410                save_stash &&
 411                say '(To restore them type "git stash apply")'
 412        else
 413                usage
 414        fi
 415        ;;
 416esac